-------------------------------------------------------------------------
-- Project: JCPU, a portable 8-bit RISC CPU written in VHDL
-- This file: Dual-ported register file with asynchrous read

-- Copyright (C) 2007 J. Ahrensfeld

-- This library is free software; you can redistribute it and/or
-- modify it under the terms of the GNU Lesser General Public
-- License as published by the Free Software Foundation; either
-- version 2.1 of the License, or (at your option) any later version.

-- This library is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-- Lesser General Public License for more details.

-- You should have received a copy of the GNU Lesser General Public
-- License along with this library; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

-- For questions and ideas, please contact the author at jens@jayfield.org

-----------------------------------------------------------------------
-- $Header: D:\usr\cvsroot/VHDL/lib/misc/dpram_1w1r2c_sim.vhd,v 1.1 2013/02/07 14:15:38 jens Exp $
-----------------------------------------------------------------------

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;

entity dpram_1w1r2c is
	Generic (
		addr_width : integer := 3;
		data_width : integer := 8
	);
	Port (
		clk_a		: in  STD_LOGIC;
		clk_b		: in  STD_LOGIC;
		en_a		: in  STD_LOGIC;
		en_b		: in  STD_LOGIC;
		we_a		: in  STD_LOGIC;
		addr_a		: in  unsigned (addr_width-1 downto 0);
		addr_b		: in  unsigned (addr_width-1 downto 0);
		din_a		: in  unsigned (data_width-1 downto 0);
		dout_b		: out unsigned (data_width-1 downto 0)
	);
end dpram_1w1r2c;

architecture Behavioral of dpram_1w1r2c is

	constant depth : integer := 2**addr_width;
	type RAMtype is array (0 to depth-1) of unsigned (data_width-1 downto 0);
	signal RAM : RAMtype;
	signal addr_b_r : unsigned (addr_width-1 downto 0);
	
begin

	dout_b <= RAM(to_integer(addr_b_r));

process (clk_a)
begin
if clk_a'event and clk_a = '1' then
	if en_a = '1' then
		if we_a = '1' then
			RAM(to_integer(addr_a)) <= din_a;
		end if;
	end if;
end if;
end process;

process (clk_b)
begin
if clk_b'event and clk_b = '1' then
	if en_b = '1' then
		addr_b_r	<= addr_b;
	end if;
end if;
end process;


end Behavioral;

